package l13_lambda;

import java.util.ArrayList;
import java.util.List;
import java.util.function.BiPredicate;

class BiPredicateTest {
	public static void main(String... args) {

		List<Integer> list1 = List.of(12, 5, 45, 18);
		List<Integer> list2 = List.of(14, 43, 3, 34, 12);
		System.out.println(findNumbers(list1, list2, (n1, n2) -> (n1 + n2) > 50));
	}

	private static List<List<Integer>> findNumbers(List<Integer> list1, List<Integer> list2,
			BiPredicate<Integer, Integer> biPredicate) {
		List<List<Integer>> newList = new ArrayList<>();
		for (Integer i : list1) {
			for (Integer j : list2) {
				if (biPredicate.test(i, j)) {
					newList.add(List.of(i, j));
				}
			}
		}
		return newList;
	}
}
